#!/usr/bin/python

import os, re, string, sys
from optparse import OptionParser

from pysqlite2 import dbapi2 as sqlite
#import sqlite

usage = "usage: %prog -i [dbfile] [options]"
version = "1.0 by Garrett Gee <garrett - at - garrettgee.com>"
parser = OptionParser(usage=usage,version=version)
parser.add_option("-i", "--inputfile", dest="inputfile", help="dat input file")
parser.add_option("-o", "--outputfile", dest="outputfile", help="if not defined, will create html file based on filename")
parser.add_option("-v", "--verbose", action="store_true", dest="verbose", help="")
parser.add_option("-d", "--debug", action="store_true", dest="debug", help="")

(options, args) = parser.parse_args()

if (not (options.inputfile)) or (not os.path.isfile(options.inputfile)):
    parser.print_help()
    sys.exit()

dbfile = options.inputfile
txtfile = options.outputfile
verbose = options.verbose
debug = options.debug
#------------------------------------------
if not (txtfile):
    (txtfile,ext) = os.path.splitext(dbfile)
    txtfile = txtfile + "-manual.html"
    
if debug:
    print "Inputfile: " + dbfile    
    print "Outputfile: " + txtfile

if os.path.isfile(txtfile):
    ##this should be a choice box
    print "Removing old " + txtfile
    os.remove(txtfile)    
#------------------------------------------
cx = sqlite.connect(dbfile)
cu = cx.cursor()

fh = open(txtfile, "a")
fh.write("<html><head><title>Manual Review Nessus Report for " + dbfile + "</title></head><body>\n\n")

#High - 23842 - JMX web console
cu.execute("select IP, port, notes from nessus where pluginid=\"23842\" order by IP;")
res = cu.fetchall()
if res:
    fh.write("<b>JBoss that allows unauthenticated access to the JMX and/or Web Console servlets (High):</b><br>\n")
    for row in res:
        notes = row[2]
        list = string.split(notes, "\\n\\n")
        link = list[-2].strip()
        
        fh.write("<a href=\"" + link + "\">" + link + "</a><br>\n")
    fh.write("<br>")
    
#Med - 25525 - snoop.jsp non persistent xss 
cu.execute("select IP, port, notes from nessus where pluginid=\"25525\" order by IP;")
res = cu.fetchall()
if res:
    fh.write("<b>snoop.jsp non persistent xss (Med):</b><br>\n")
    fh.write("location unknown. possibly at /examples/jsp/snp/snoop.jsp<br>\n")
    for row in res:
        ip = row[0]
        port = str(row[1])
        notes = row[2]
        
        fh.write("<a href=\"http://" + ip + ":" + port + "\">" + ip + ":" + port + "</a><br>\n")
    fh.write("<br>")
    
#Med - 35806 - cal2.jsp non persistent xss 
cu.execute("select IP, port, notes from nessus where pluginid=\"35806\" order by IP;")
res = cu.fetchall()
if res:
    fh.write("<b>cal2.jsp non persistent xss (Med):</b><br>\n")
    fh.write("location unknown. possibly in /examples/ directory<br>\n")
    for row in res:
        ip = row[0]
        port = str(row[1])
        notes = row[2]
        
        fh.write("<a href=\"http://" + ip + ":" + port + "\">" + ip + ":" + port + "</a><br>\n")
    fh.write("<br>")
    
#Med-Low 12085 default web files
cu.execute("select IP, port, notes from nessus where pluginid=\"12085\" order by IP;")
res = cu.fetchall()
if res:
    fh.write("<b>Default example web files (Med-Low):</b><br>\n")
    for row in res:
        ip = row[0]
        port = str(row[1])
        notes = row[2]
        
        paths = string.split(notes, "\\n\\n")
        paths = paths[-2].strip()
        path = string.split(paths, "\\n")
        for link in path:
            link = link.strip()
            fh.write("<a href=\"http://" + ip + ":" + port + link + "\">" + ip + ":" + port + link + "</a><br>\n")
    fh.write("<br>")

#Med-Low 24260 http options
cu.execute("select IP, port, notes from nessus where pluginid=\"24260\" and notes not like \"%Options allowed : (Not implemented)%\" and notes like \"%options%\" order by IP;")
res = cu.fetchall()
if res:
    fh.write("<b>HTTP options (Med-Low):</b><br>\n")
    fh.write("manually test for trace/track/put/delete<br>\n")
    
    for row in res:
        ip = row[0]
        port = str(row[1])
        notes = row[2]
        
        data = string.split(notes, "\\n")
        for row in data:
            if "OPTIONS" in row:
                options = row
                options = options.strip("\\r")
                fh.write(ip + ":" + port + ": " + options + "<br>\n")
        
    fh.write("<br>")

#Low - 10263 - smtp servers
cu.execute("select IP, port, notes from nessus where pluginid=\"10263\" order by IP;")
res = cu.fetchall()
if res:
    fh.write("<b>smtp servers (Low):</b><br>\n")
    fh.write("test smtp servers for vrfy/expn/___ via smtptest.pl<br>\n")
    for row in res:
        ip = row[0]
        port = str(row[1])
        notes = row[2]
        
        fh.write(ip + ":" + port + "<br>\n")
    fh.write("<br>")

#Low - 11422 - webserver not configured
cu.execute("select IP, port, notes from nessus where pluginid=\"11422\" order by IP;")
res = cu.fetchall()
if res:
    fh.write("<b>webserver not configured (Low):</b><br>\n")
    for row in res:
        ip = row[0]
        port = str(row[1])
        notes = row[2]
        
        fh.write("<a href=\"http://" + ip + ":" + port + "\">" + ip + ":" + port + "</a><br>\n")
    fh.write("<br>")

#Unknown - 10107 - generic web server detection
##cu.execute("select distinct IP from nessus where pluginid=\"10107\" order by IP asc")
##res_ip = cu.fetchall()
##if res_ip:
##    fh.write("<b>web servers:</b><br>\n")
##    for row in res_ip:
##        ip = row[0]
##        header = "" + ip + ": \n"
##        
##        cu.execute("select distinct port from nessus where IP = ? and pluginid = \"10107\"", (ip,))
##        res_tcp = cu.fetchall()
##        tcplist = ""
##        first = 1
##        for row_tcp in res_tcp:
##            port = str(row_tcp[0])
##            port = "<a href=\"http://" + ip + ":" + port + "\">" + port + "</a>"
##            if first:
##                tcplist = port
##                first = 0
##            else:
##                tcplist = tcplist + ", " + port    
##        
##        line = header + tcplist
##        fh.write(line + "<br>\n")
##        if verbose:            
##            print line
##    fh.write("<br>")

#Unknown - 24260 - generic http test - better than 10107
#10107 didnt show all the http ports <- why not? seemed like the check only fired a few times when reviewing the raw results

cu.execute("select distinct IP from nessus where pluginid=\"24260\" order by IP asc")
#notes like \"%SSL : no%\"
#cu.execute("select distinct IP from nessus where pluginid=\"24260\" order by IP asc")
res_ip = cu.fetchall()
if res_ip:
    fh.write("<b>web servers:</b><br>\n")
    for row in res_ip:
        ip = row[0]
        
        header = "" + ip + ": \n"
        
        cu.execute("select port, notes from nessus where IP = ? and pluginid = \"24260\"", (ip,))
        res_tcp = cu.fetchall()
        tcplist = ""
        first = 1
        for row_tcp in res_tcp:
            port = str(row_tcp[0])
            notes = row_tcp[1]
            
            if "SSL : no" in notes:
                port = "<a href=\"http://" + ip + ":" + port + "\">" + port + "</a>"
            else:
                port = "<a href=\"https://" + ip + ":" + port + "\">" + port + "</a>"
            
            if first:
                tcplist = port
                first = 0
            else:
                tcplist = tcplist + ", " + port    
        
        line = header + tcplist
        fh.write(line + "<br>\n")
        if verbose:            
            print line
    fh.write("<br>")

fh.write("</body></html>")
fh.close()

